/***************************************************************************
                          envoi_dialog.cpp  -  description
                             -------------------
    begin                : Fri Oct 6 2000
    copyright            : (C) 2000 by Mickael Marchand / Gregory Thiemonge
    email                : MikMak@users.sourceforge.net / cannibal@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "envoi_dialog.h"
#include <kmsgbox.h>
#include <kapp.h>
#include "people.h"

extern QString hostname;
extern QStrList favoris;
extern QStrList existing_alias;
extern QList<people> list_people;
extern QString appdir;

envoi_dialog::envoi_dialog(QWidget *parent=0, const char *name=0,bool isreply=false,QString to="",QString header="") : QDialog(parent,name,true){
				initDialog();
				initTree();
			  this->resize(420,290);
        sender_text->setText(hostname);
        Show_Favoris();
if (isreply){
        this->setCaption(i18n("Reply ..."));
        dest_combo->setEditText(to);
        envoi_text->setText(header);
        envoi_text->setFocus();
        envoi_text->setCursorPosition(3,0,false);
}
else this->setCaption(i18n("New message..."));
connect (Button_Ok,SIGNAL(clicked()),SLOT(slotOkClicked()));
connect (Button_Cancel,SIGNAL(clicked()),SLOT(slotCancelClicked()));
connect (show_alias,SIGNAL(clicked()),SLOT(slot_Show_Alias()));
connect (browse,SIGNAL(clicked()),SLOT(slot_Browse()));
}

envoi_dialog::~envoi_dialog(){
}

void envoi_dialog::slotCancelClicked(){
this->reject();
}

void envoi_dialog::slotOkClicked(){
QString tmp_combo(dest_combo->currentText());
tmp_combo = tmp_combo.upper();

int a;
int dejala=0;
if (!show_alias->isChecked())
{
        for (a = 0 ; a <= (int)favoris.count()-1 ; a++) {
                if (favoris.contains(tmp_combo)){
                dejala = 1;
                favoris.find(tmp_combo);
                break;
                }
        }

  if (dejala == 0 && (int)favoris.count() !=10 ) {
                favoris.append(tmp_combo);
        }
        else
        {
                                if ( (int)favoris.count() == 10 && dejala == 0 ) {
                                                favoris.remove(2);
                                                favoris.append(tmp_combo);
                                                }
        }
}
QString orig (sender_text->text());
QString message (envoi_text->text());
message = FormatString(message);
QString dest1;
QString dest_rest(tmp_combo);
Popups *nouveau = new Popups();
int nb = tmp_combo.contains(';');
int i,repere;

if (!nb && !show_alias->isChecked()) nouveau->new_popup(false,tmp_combo,orig,tmp_combo,message);
else if (!nb && show_alias->isChecked()) nouveau->new_popup(true,tmp_combo,orig,tmp_combo,message);
else
{
        for (i=0; i <= nb ; i++)
                {
                repere = dest_rest.find(';');
                dest1 = dest_rest.left(repere);
                dest_rest = dest_rest.right(strlen(dest_rest)-repere-1);
                if (show_alias->isChecked() && existing_alias.contains(dest1)) nouveau->new_popup(true,dest1,orig,tmp_combo,message);
                else nouveau->new_popup(false,dest1,orig,tmp_combo,message);
                }
}

this->accept();
}

void envoi_dialog::slot_Show_Alias(){
if (show_alias->isChecked())
        {
        dest_combo->clear();
        int tmp=0;
        QString temp;
        for ( tmp = existing_alias.count()-1 ; tmp >= 0  ; tmp--)
                {
                temp = existing_alias.at(tmp);
                if (temp == temp.upper())       dest_combo->insertItem(temp,-1);
                }
        }
else Show_Favoris();
}

void envoi_dialog::Show_Favoris(){
dest_combo->clear();
int tmp=0;
for ( tmp = (int)favoris.count()-1 ; tmp >= 0  ; tmp--)
        {
        dest_combo->insertItem(favoris.at(tmp),-1);
        }
}

QString envoi_dialog::FormatString(QString m){
int i=0;
int j = m.contains('\n');
int idx=0;

while (i < j)
        {
        idx =   m.find('\n',idx+2);
        m.insert(idx,'\r');
        i++;
        }
return m;
}

void envoi_dialog::slot_Browse(){
if (this->width()> 421)
	{
	this->resize(420,290);
	}
else
	{
	this->resize(650,290);
	}
}

void envoi_dialog::initTree(){
QPixmap mach(appdir + "/pics/machine.xpm");
QPixmap group(appdir + "/pics/group.xpm");
QStrList listgroup;
QString temp;
int idx=-1;
unsigned int i,j;
for (i=0;i<list_people.count();i++)
	{
	if (!listgroup.contains(list_people.at(i)->get_workgroup()) && list_people.at(i)->get_workgroup()!="")
			{
      listgroup.append(list_people.at(i)->get_workgroup()); //new group in list
			//finding people in this group
			for (j=0;j<list_people.count();j++){
      	if (list_people.at(j)->get_workgroup()==list_people.at(i)->get_workgroup() && list_people.at(j)->get_name()!="" ) listgroup.append(list_people.at(j)->get_name());
			}
			}
	}
for (i=0;i<listgroup.count();i++)
{
if (listgroup.at(i)!="") temp = listgroup.at(i);
else {
i++;
temp = listgroup.at(i);
}
if (temp==temp.upper())
	{
	tree->insertItem (temp,&group,-1);
	idx++;
	}
else
	{
	tree->addChildItem(temp, &mach, idx);
	}
}
#ifdef DBG
for (i=0;i<listgroup.count();i++)
{
printf ("%s\n", listgroup.at(i));
}
#endif
connect (tree,SIGNAL(selected(int)),SLOT(slot_Select(int)));
}

void envoi_dialog::slot_Select(int idx){
QString temp(dest_combo->currentText());
if (temp.right(1)==";" || temp.isEmpty())
	{
   dest_combo->setEditText(temp+tree->itemAt(idx)->getText());
	}
else
	{
   dest_combo->setEditText(temp+";"+tree->itemAt(idx)->getText());
	}
}
