/***************************************************************************
                          reception.cpp  -  description
                             -------------------
    begin                : Mon Apr 17 2000
    copyright            : (C) 2000 by Mickal Marchand
    email                : MikMak@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "reception.h"
#include <stdio.h>

extern QString appdir;
extern bool loguer;

Reception::Reception(){
persos_dest = new QStrList (true);
persos_orig = new QStrList (true);
persos_mess = new QStrList (true);
groupe_dest = new QStrList (true);
groupe_orig = new QStrList (true);
groupe_mess = new QStrList (true);
autres_dest = new QStrList (true);
autres_orig = new QStrList (true);
autres_mess = new QStrList (true);
new_persos = new QStrList (true);
new_groupe = new QStrList (true);
new_autres = new QStrList (true);
ip_persos = new QStrList (true);
ip_groupe = new QStrList (true);
ip_autres = new QStrList (true);
nombre_popups_persos = 0;
nombre_popups_groupe = 0;
nombre_popups_autres = 0;
nombre_popups_total = 0;
courant_perso = 0;
courant_groupe = 0;
courant_autres = 0;
}

Reception::~Reception(){
}

void Reception::Add_popup (QString message,QString from,QString to,QString ip, int type){
if (loguer) Log (message,from,to);
switch (type){
	case 1:
	persos_dest.append (to);
	persos_orig.append (from);
	persos_mess.append (message);
	ip_persos.append (ip);
	nombre_popups_persos += 1;
	nombre_popups_total +=1;
	courant_perso = nombre_popups_persos - 1;
	new_persos.append("true");
	break;
	case 2:
	groupe_dest.append (to);
	groupe_orig.append (from);
	groupe_mess.append (message);
	ip_groupe.append (ip);
	nombre_popups_groupe += 1;
	nombre_popups_total +=1;
	courant_groupe = nombre_popups_groupe - 1;
	new_groupe.append("true");
	break;
	case 3:
	autres_dest.append (to);
	autres_orig.append (from);
	autres_mess.append (message);
	ip_autres.append (ip);
	nombre_popups_autres += 1;
	nombre_popups_total +=1;
	courant_autres = nombre_popups_autres - 1;
	new_autres.append("true");
	break;
}
}

void Reception::Del_popup(int id, int type){
switch (type){
	case 0:
if (!persos_dest.remove (id)) printf("remove1 error\n");
if (!persos_orig.remove (id)) printf ("remove2 error\n");
if (!persos_mess.remove (id)) printf ("remove3 error\n");
if (!ip_persos.remove (id)) printf ("remove4 error\n");
if (!new_persos.remove(id)) printf ("remove41 error\n");
	nombre_popups_persos -= 1;
	nombre_popups_total -=1;
	if (id) {courant_perso = id - 1;}
	else {courant_perso=0;}
	if (nombre_popups_persos < 0)	nombre_popups_persos = 0;
	break;
	case 1:
if (!groupe_dest.remove (id)) printf ("remove5 error\n");
if (!groupe_orig.remove (id)) printf ("remove6 error\n");
if (!groupe_mess.remove (id)) printf ("remove7 error\n");
if (!ip_groupe.remove (id)) printf ("remove8 error\n");
if (!new_groupe.remove(id)) printf ("remove42 error\n");
	nombre_popups_groupe -= 1;
	nombre_popups_total -=1;
	if (id) {courant_groupe = id - 1;}
	else {courant_groupe=0;}
	if (nombre_popups_groupe < 0)	nombre_popups_groupe = 0;
	break;
	case 2:
if (!autres_dest.remove (id))  printf ("remove9 error\n");
if (!autres_orig.remove (id)) printf ("remove10 error\n");
if (!autres_mess.remove (id)) printf ("remove11 error\n");
if (!ip_autres.remove (id)) printf ("remove12 error\n");
if (!new_autres.remove(id)) printf ("remove43 error\n");
	nombre_popups_autres -= 1;
	nombre_popups_total -=1;
	if (id) {courant_autres = id - 1;}
	else {courant_autres=0;}
	if (nombre_popups_autres < 0)	nombre_popups_autres = 0;
	break;
}
if (nombre_popups_total < 0) nombre_popups_total = 0;
}

void Reception::Log(QString m,QString o,QString d){
enhancedperms();
int file;
QString tolog("Message from : ");
tolog += o + "  : " + d + '\n' + m +"\n*******************************\n\n";

if (access (appdir + "/log.txt", F_OK))
  file = open (appdir + "/log.txt", O_WRONLY | O_CREAT, DATA_PERM);
else
  file = open (appdir + "/log.txt", O_WRONLY | O_APPEND, DATA_PERM);

(void) lock_reg (file, F_SETLKW, F_WRLCK, 0, SEEK_SET, 0);
write (file, tolog, strlen(tolog));
(void) lock_reg (file, F_SETLK, F_UNLCK, 0, SEEK_SET, 0);
close (file);
normalperms();
}
